function [M,YY,AY] = FcstSetup()

% Get estimation sample period data and set the state selection matrix M
%

% Form the reduced-state selection matrix
%
% The state variable ordering is:
% y,c,i,k,,bar,L,m,mc,pi,R,rk,u,w,wtil,xi,xik,z,phi,mu,b,g,laf,Ec,Epi,
% Erk,Ew,Ewtil,Exi,Exik,Ei,yl,cl,il,wl,ml
%
% The 'true' state variables are c,i,kbar,R,w,z,phi,mu,b,g,laf which are
% indexed as 2,3,5,10,13,17,18,19,20,21,22
%
% note that pi is not a state when the estimated model shuts down inflation
% indexation, as we have done here.
%
M = zeros(35,11);
M(2,1)   = 1;
M(3,2)   = 1;
M(5,3)   = 1;
M(10,4)  = 1;
M(13,5)  = 1;
M(17,6)  = 1;
M(18,7)  = 1;
M(19,8)  = 1;
M(20,9)  = 1;
M(21,10) = 1;
M(22,11) = 1;

% load data to start the forecast simulations. Row 217 is 2008Q3
[YY,YY_txt,YY_raw] = xlsread('usModelData.xls','Sheet3','b119:h214');

% Load the auxiliary variables
% Sample data 1984Q1 to 2007Q4 
[AY,AY_txt,AY_raw] = xlsread('auxvars2.xls','Sheet2','b101:e196');

