clear;

nestim = 27;
nstep = 12;
fcastmat = zeros(3,nestim+1,nstep);

sa1  = xlsread('auxvars2.xls','Sheet2','a169:e196');
sa2  = xlsread('auxvars2.xls','Sheet2','a170:e196');
sa4  = xlsread('auxvars2.xls','Sheet2','a172:e196');
sa12 = xlsread('auxvars2.xls','Sheet2','a180:e196');

disp(sprintf('forecasting pce inflation\n'))
for j = 0:nestim
    
     var = 1;  % pce
    
     % load estimation sample data 1984Q1 to 2000Q4+j
     str1 = 186+j;
     [YY,txt,raw] = xlsread('usModelData.xls','Sheet3',strcat('a119:h',num2str(str1)));

     str2 = 168+j;
     [data,txt1,raw1] = xlsread('auxvars2.xls','Sheet2',strcat('a101:e',num2str(str2)));

     dv  = data(:,var);
     
     
     lagv  = [1,2,4,12];
     
     for i = 1:4
         
        lag = lagv(i);
        
        y  = [];
        yl = [];
        x  = [];
     
        y  = dv(1+lag:end);
        yl = dv(1:end-lag);
        x  = YY(1:end-lag,:);
     
        [n,c] = size(x);
        x = [ones(n,1),x,yl];
     
        bhat = (x'*x)\x'*y;
     
        yp(j+1,i) = [1,YY(end,:),y(end)]*bhat;
     end
     
     % AR1 forecasts (this does full 12 steps
        yar1          = ar1_fcst2(dv,nstep);
        ar1mat(j+1,:) = yar1;
     
end

 s1  = yp(1:end,1)     -  sa1(:,var);
 s2  = yp(1:end-1,2)   -  sa2(:,var);
 s4  = yp(1:end-3,3)   -  sa4(:,var);
 s12 = yp(1:end-11,4) -  sa12(:,var);

 rmse1  = sqrt( s1'*s1/max(size(s1)) );
 rmse2  = sqrt(s2'*s2/max(size(s2)));
 rmse4  = sqrt(s4'*s4/max(size(s4)));
 rmse12 = sqrt(s12'*s12/max(size(s12)));
 
 omat(var,:) = [rmse1,rmse2,rmse4,rmse12];
 
ars1  = ar1mat(1:end,1)     -  sa1(:,var);
ars2  = ar1mat(1:end-1,2)   -  sa2(:,var);
ars4  = ar1mat(1:end-3,4)   -  sa4(:,var);
ars12 = ar1mat(1:end-11,12) -  sa12(:,var);

arrmse1  = sqrt( ars1'*ars1/max(size(ars1)) );
arrmse2  = sqrt(ars2'*ars2/max(size(ars2)));
arrmse4  = sqrt(ars4'*ars4/max(size(ars4)));
arrmse12 = sqrt(ars12'*ars12/max(size(ars12)));

arpmat(var,:) = [arrmse1,arrmse2,arrmse4,arrmse12];

% Diebold-Mariano

dm = zeros(4,4);

% Set variable index here:
vi = 1;

dmLossFnIndex = 1;
dmTestType    = 'two-sided' ;
   
dmForecast1 = yp(1:end,1);
dmForecast2 = ar1mat(1:end,1);
dmActual    = sa1(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 1);
dm(1,:) = [DM,MDM,DM_pval,MDM_pval];                        


dmForecast1 = yp(1:end-1,2);
dmForecast2 = ar1mat(1:end-1,2);
dmActual    = sa2(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 2);
dm(2,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-3,3);
dmForecast2 = ar1mat(1:end-3,4);
dmActual    = sa4(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 4);
dm(3,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-11,4);
dmForecast2 = ar1mat(1:end-11,12);
dmActual    = sa12(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 12);

dm(4,:) = [DM,MDM,DM_pval,MDM_pval];                  
%     

MDMmat(var,:) = [dm(1,4),dm(2,4),dm(3,4),dm(4,4)];


%%
disp(sprintf('forecasting core pce inflation\n')) 
 for j = 0:nestim
    
     var = 2;  % cpce
    
     % load estimation sample data 1984Q1 to 2000Q4+j
     str1 = 186+j;
     [YY,txt,raw] = xlsread('usModelData.xls','Sheet3',strcat('a119:h',num2str(str1)));

     str2 = 168+j;
     [data,txt1,raw1] = xlsread('auxvars2.xls','Sheet2',strcat('a101:e',num2str(str2)));

     dv  = data(:,var);
     
     
     lagv  = [1,2,4,12];
     
     for i = 1:4
         
        lag = lagv(i);
        
        y  = [];
        yl = [];
        x  = [];
     
        y  = dv(1+lag:end);
        yl = dv(1:end-lag);
        x  = YY(1:end-lag,:);
     
        [n,c] = size(x);
        x = [ones(n,1),x,yl];
     
        bhat = (x'*x)\x'*y;
     
        yp(j+1,i) = [1,YY(end,:),y(end)]*bhat;
     end
     
      % AR1 forecasts
        yar1          = ar1_fcst2(dv,nstep);
        ar1mat(j+1,:) = yar1;
     
end

 s1  = yp(1:end,1)     -  sa1(:,var);
 s2  = yp(1:end-1,2)   -  sa2(:,var);
 s4  = yp(1:end-3,3)   -  sa4(:,var);
 s12 = yp(1:end-11,4) -  sa12(:,var);

 rmse1  = sqrt( s1'*s1/max(size(s1)) );
 rmse2  = sqrt(s2'*s2/max(size(s2)));
 rmse4  = sqrt(s4'*s4/max(size(s4)));
 rmse12 = sqrt(s12'*s12/max(size(s12)));
 
 omat(var,:) = [rmse1,rmse2,rmse4,rmse12];
 
ars1  = ar1mat(1:end,1)     -  sa1(:,var);
ars2  = ar1mat(1:end-1,2)   -  sa2(:,var);
ars4  = ar1mat(1:end-3,4)   -  sa4(:,var);
ars12 = ar1mat(1:end-11,12) -  sa12(:,var);

arrmse1  = sqrt( ars1'*ars1/max(size(ars1)) );
arrmse2  = sqrt(ars2'*ars2/max(size(ars2)));
arrmse4  = sqrt(ars4'*ars4/max(size(ars4)));
arrmse12 = sqrt(ars12'*ars12/max(size(ars12)));

arpmat(var,:) = [arrmse1,arrmse2,arrmse4,arrmse12];

dm = zeros(4,4);

% Set variable index here:
vi = 2;

dmLossFnIndex = 1;
dmTestType    = 'two-sided' ;
   
dmForecast1 = yp(1:end,1);
dmForecast2 = ar1mat(1:end,1);
dmActual    = sa1(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 1);
dm(1,:) = [DM,MDM,DM_pval,MDM_pval];                        


dmForecast1 = yp(1:end-1,2);
dmForecast2 = ar1mat(1:end-1,2);
dmActual    = sa2(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 2);
dm(2,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-3,3);
dmForecast2 = ar1mat(1:end-3,4);
dmActual    = sa4(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 4);
dm(3,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-11,4);
dmForecast2 = ar1mat(1:end-11,12);
dmActual    = sa12(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 12);

dm(4,:) = [DM,MDM,DM_pval,MDM_pval];                  
%     
MDMmat(var,:) = [dm(1,4),dm(2,4),dm(3,4),dm(4,4)];
 
% 
 %%
 disp(sprintf('forecasting unemployment rate\n'))
  for j = 0:nestim
    
     var = 3;  % unemployment rate
    
     % load estimation sample data 1984Q1 to 2000Q4+j
     str1 = 186+j;
     [YY,txt,raw] = xlsread('usModelData.xls','Sheet3',strcat('a119:h',num2str(str1)));

     str2 = 168+j;
     [data,txt1,raw1] = xlsread('auxvars2.xls','Sheet2',strcat('a101:e',num2str(str2)));

     dv  = data(:,var);
     
     
     lagv  = [1,2,4,12];
     
     for i = 1:4
         
        lag = lagv(i);
        
        y  = [];
        yl = [];
        x  = [];
     
        y  = dv(1+lag:end);
        yl = dv(1:end-lag);
        x  = YY(1:end-lag,:);
     
        [n,c] = size(x);
        x = [ones(n,1),x,yl];
     
        bhat = (x'*x)\x'*y;
     
        yp(j+1,i) = [1,YY(end,:),y(end)]*bhat;
     end
     
      % AR1 forecasts
        yar1          = ar1_fcst2(dv,nstep);
        ar1mat(j+1,:) = yar1;
     
end

 s1  = yp(1:end,1)     -  sa1(:,var);
 s2  = yp(1:end-1,2)   -  sa2(:,var);
 s4  = yp(1:end-3,3)   -  sa4(:,var);
 s12 = yp(1:end-11,4) -  sa12(:,var);

 rmse1  = sqrt( s1'*s1/max(size(s1)) );
 rmse2  = sqrt(s2'*s2/max(size(s2)));
 rmse4  = sqrt(s4'*s4/max(size(s4)));
 rmse12 = sqrt(s12'*s12/max(size(s12)));
 
 omat(var,:) = [rmse1,rmse2,rmse4,rmse12];
 
 ars1  = ar1mat(1:end,1)     -  sa1(:,var);
ars2  = ar1mat(1:end-1,2)   -  sa2(:,var);
ars4  = ar1mat(1:end-3,4)   -  sa4(:,var);
ars12 = ar1mat(1:end-11,12) -  sa12(:,var);

arrmse1  = sqrt( ars1'*ars1/max(size(ars1)) );
arrmse2  = sqrt(ars2'*ars2/max(size(ars2)));
arrmse4  = sqrt(ars4'*ars4/max(size(ars4)));
arrmse12 = sqrt(ars12'*ars12/max(size(ars12)));

arpmat(var,:) = [arrmse1,arrmse2,arrmse4,arrmse12];

dm = zeros(4,4);

% Set variable index here:
vi = 3;

dmLossFnIndex = 1;
dmTestType    = 'two-sided' ;
   
dmForecast1 = yp(1:end,1);
dmForecast2 = ar1mat(1:end,1);
dmActual    = sa1(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 1);
dm(1,:) = [DM,MDM,DM_pval,MDM_pval];                        


dmForecast1 = yp(1:end-1,2);
dmForecast2 = ar1mat(1:end-1,2);
dmActual    = sa2(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 2);
dm(2,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-3,3);
dmForecast2 = ar1mat(1:end-3,4);
dmActual    = sa4(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 4);
dm(3,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-11,4);
dmForecast2 = ar1mat(1:end-11,12);
dmActual    = sa12(:,vi);

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 12);

dm(4,:) = [DM,MDM,DM_pval,MDM_pval];                  
%     
MDMmat(var,:) = [dm(1,4),dm(2,4),dm(3,4),dm(4,4)];

 disp(sprintf('forecasting housing starts\n'))
  for j = 0:nestim
    
     var = 4;  % housing starts
    
     % load estimation sample data 1984Q1 to 2000Q4+j
     str1 = 186+j;
     [YY,txt,raw] = xlsread('usModelData.xls','Sheet3',strcat('a119:h',num2str(str1)));

     str2 = 168+j;
     [data,txt1,raw1] = xlsread('auxvars2.xls','Sheet2',strcat('a101:e',num2str(str2)));

     dv  = data(:,var)/1000;
     
     
     lagv  = [1,2,4,12];
     
     for i = 1:4
         
        lag = lagv(i);
        
        y  = [];
        yl = [];
        x  = [];
     
        y  = dv(1+lag:end);
        yl = dv(1:end-lag);
        x  = YY(1:end-lag,:);
     
        [n,c] = size(x);
        x = [ones(n,1),x,yl];
     
        bhat = (x'*x)\x'*y;
     
        yp(j+1,i) = [1,YY(end,:),y(end)]*bhat;
     end
     
      % AR1 forecasts
        yar1          = ar1_fcst2(dv,nstep);
        ar1mat(j+1,:) = yar1;
     
end

 s1  = yp(1:end,1)     -  sa1(:,var)/1000;
 s2  = yp(1:end-1,2)   -  sa2(:,var)/1000;
 s4  = yp(1:end-3,3)   -  sa4(:,var)/1000;
 s12 = yp(1:end-11,4) -  sa12(:,var)/1000;

 rmse1  = sqrt( s1'*s1/max(size(s1)) );
 rmse2  = sqrt(s2'*s2/max(size(s2)));
 rmse4  = sqrt(s4'*s4/max(size(s4)));
 rmse12 = sqrt(s12'*s12/max(size(s12)));
 
 omat(var,:) = [rmse1,rmse2,rmse4,rmse12];
 
 ars1  = ar1mat(1:end,1)     -  sa1(:,var)/1000;
ars2  = ar1mat(1:end-1,2)   -  sa2(:,var)/1000;
ars4  = ar1mat(1:end-3,4)   -  sa4(:,var)/1000;
ars12 = ar1mat(1:end-11,12) -  sa12(:,var)/1000;

arrmse1  = sqrt( ars1'*ars1/max(size(ars1)) );
arrmse2  = sqrt(ars2'*ars2/max(size(ars2)));
arrmse4  = sqrt(ars4'*ars4/max(size(ars4)));
arrmse12 = sqrt(ars12'*ars12/max(size(ars12)));

arpmat(var,:) = [arrmse1,arrmse2,arrmse4,arrmse12];
%  
dm = zeros(4,4);

% Set variable index here:
vi = 4;

dmLossFnIndex = 1;
dmTestType    = 'two-sided' ;
   
dmForecast1 = yp(1:end,1);
dmForecast2 = ar1mat(1:end,1);
dmActual    = sa1(:,vi)/1000;

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 1);
dm(1,:) = [DM,MDM,DM_pval,MDM_pval];                        


dmForecast1 = yp(1:end-1,2);
dmForecast2 = ar1mat(1:end-1,2);
dmActual    = sa2(:,vi)/1000;

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 2);
dm(2,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-3,3);
dmForecast2 = ar1mat(1:end-3,4);
dmActual    = sa4(:,vi)/1000;

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 4);
dm(3,:) = [DM,MDM,DM_pval,MDM_pval];                        

dmForecast1 = yp(1:end-11,4);
dmForecast2 = ar1mat(1:end-11,12);
dmActual    = sa12(:,vi)/1000;

[DM, MDM, DM_pval, MDM_pval] = ...
           Diebold_Mariano(dmForecast1, dmForecast2, dmActual, ...
                           dmLossFnIndex, dmTestType, 12);

dm(4,:) = [DM,MDM,DM_pval,MDM_pval];                  
%     
MDMmat(var,:) = [dm(1,4),dm(2,4),dm(3,4),dm(4,4)];

% 

%%

% output

 disp(sprintf('RMSE results for alternative prediction model'))
 disp(sprintf('Aux var        h=1      h=2      h=4      h=12'))
 disp(sprintf('__________________________________________________'))
 disp(sprintf('pce         %7.2f  %7.2f  %7.2f  %7.2f',omat(1,:)))
 disp(sprintf('AR(1)       %7.2f  %7.2f  %7.2f  %7.2f',arpmat(1,:)))
 disp(sprintf('MDM pval    %7.2f  %7.2f  %7.2f  %7.2f',MDMmat(1,:)))
 disp(sprintf('__________________________________________________'))
 disp(sprintf('core pce    %7.2f  %7.2f  %7.2f  %7.2f',omat(2,:)))
 disp(sprintf('AR(1)       %7.2f  %7.2f  %7.2f  %7.2f',arpmat(2,:)))
 disp(sprintf('MDM pval    %7.2f  %7.2f  %7.2f  %7.2f',MDMmat(2,:)))
 disp(sprintf('__________________________________________________'))
 disp(sprintf('unemp rate  %7.2f  %7.2f  %7.2f  %7.2f',omat(3,:)))
 disp(sprintf('AR(1)       %7.2f  %7.2f  %7.2f  %7.2f',arpmat(3,:)))
 disp(sprintf('MDM pval    %7.2f  %7.2f  %7.2f  %7.2f',MDMmat(3,:)))
 disp(sprintf('__________________________________________________'))
 disp(sprintf('housing sts %7.2f  %7.2f  %7.2f  %7.2f',omat(4,:)))
 disp(sprintf('AR(1)       %7.2f  %7.2f  %7.2f  %7.2f',arpmat(4,:)))
 disp(sprintf('MDM pval    %7.2f  %7.2f  %7.2f  %7.2f',MDMmat(4,:)))
 disp(sprintf('__________________________________________________'))
 
dm_omat = MDMmat;
 fname = 'table6_altreg';
save(fname,'omat','dm_omat');
 
%  
%  
%  
%  
%  
% 
