function ypred = fcast_mvars2(DD,ZZ,smat)
%
% Forecast DSGE model state variables.
%
% Inputs:
%
%
% Output:
%
%   ypred   t x nobs_vars x max_steps array. First index is time period,
%           second index is variable, third index is step ahead begining
%           with 1.  The variable ordering is as the measurement equations
%           from sysmat.m. Here, the ordering is:
%           y(t,1,step) = real per capita GDP growth
%           y(t,2,step) = real per capita consumption growth
%           y(t,3,step) = real per capita investment growth
%           y(t,4,step) = hours worked
%           y(t,5,step) = nominal wage growth
%           y(t,6,step) = GDP deflator inflation
%           y(t,7,step) = Nominal interest rate
%

[nstates,nsteps] = size(smat);
nvar = max(size(DD));

ypred = zeros(nvar,nsteps);

for j = 1:nsteps
    
    ypred(:,j) = DD + ZZ * smat(:,j);
    
end



