function fx = normt_rnd(mu,sigma2,left,right)


    std = sqrt(sigma2);

    nobs = max(size(mu));
    
    %// calculate bounds on probabilities
    lowerProb = Phi((left-mu)./std);
    upperProb = Phi((right-mu)./std);

    %// Draw uniform from within (lowerProb,upperProb)
    u = lowerProb + (upperProb-lowerProb).*rand(nobs,1);

    %// Find quantiles
    fx = mu + Phiinv(u).*std;

 

%////////////////////////////////////////////////////////
%//
%// compute standard normal quantile function of the vector x (0,1)
%//
%////////////////////////////////////////////////////////

function fx = Phiinv(x)

    fx = sqrt(2)*erfinv(2*x-1);



%//////////////////////////////////////////////////////////
%//
%// standard normal distribution function at x
%//
%/////////////////////////////////////////////////////////

function fx = Phi(x)

    fx = 0.5*(1+erf(x/sqrt(2)));

