% Interval calculation for parameter estimates

% Read in data for last estimation window

nblocks = 70;
nsim    = 1000;
npara   = 40;

paramat = zeros(nblocks*nsim,npara);
trej = 0;

loaddate = 'output-20-Jun-2008/';



for i = 1:nblocks

    clear fname parasim;

    fname = strcat(loaddate,'smpl-1984Q1+',num2str(94),'--block-',num2str(i+(100-nblocks)));
    load(fname,'parasim','rej');
    ridx1 = (i-1)*nsim + 1;
    ridx2 = i*nsim;
    paramat(ridx1:ridx2,:) = parasim;
    trej = sum(rej) + trej;

end

% mean and standard deviation of draws
mpara = mean(paramat);
spara = std(paramat);
rej_pct = trej/(nblocks*nsim);

hpdband = hpdint(paramat,0.90);

