function ymat = pdrawsDSGE(para,state,shocks,steps)

[TT,QQ,RR,HH,DD,ZZ,VV,RC]=sysmat(para);

s = state';

ymat = [];

shocks = shocks * chol(QQ);

for i = 1:steps
    
    sn  = TT * s + RR * shocks(i,:)';
    
    ymat(:,i)   = DD + ZZ * sn;
  
    s = sn;
    
end


 function zvec = pdrawsAUX(paraDSGE,paraAUX,Yvar0,state,M,epsDSGE,shocks,steps)

[TT,QQ,RR,HH,DD,ZZ,VV,RC]=sysmat(paraDSGE);

s = state';

ymat = [];

a0  = paraAUX(1);
a1  = paraAUX(2:12);
rho = paraAUX(13);
sg  = sqrt(paraAUX(14));

z = zeros(steps+1,1);
z(1) = Yvar0;

epsDSGE = epsDSGE*chol(QQ);

for i = 1:steps
    
    sn  = TT * s + RR * epsDSGE(i,:)';
    
    z(i+1) = rho * z(i) + a0*(1-rho) + ...
        (sn' - rho .*s') * M * a1' +  sg * shocks(i,1);
 
 %z(i+1) = a0 + sn' * M * a1' ;
  
    s = sn;
    
end

zvec = z(2:end);

