function mat = theory_reduction(narray,darray,vid,nestim)
% Calculate RMSE reduction ratios given a numerator array, a denominator
% array, a variable id number, and the number of estimation periods.

% Adjust sample size so t-distribution results don't get messed up.

lastT = nestim+1;
sel_h1 =  1:lastT;
sel_h2 =  1:lastT-1;
sel_h4 =  1:lastT-3;
sel_h12 = 1:lastT-11;

% one-step ahead reduction for choice of lambda
v1n = mean(narray(1,sel_h1,1,vid));
v2n = mean(narray(2,sel_h1,1,vid));
v3n = mean(narray(3,sel_h1,1,vid));

v1d = mean(darray(1,sel_h1,1,vid));
v2d = mean(darray(2,sel_h1,1,vid));
v3d = mean(darray(3,sel_h1,1,vid));

vv1 = sqrt(v1n/v1d);
vv2 = sqrt(v2n/v2d);
vv3 = sqrt(v3n/v3d);

c1 = [vv1;vv2;vv3];

% two-step ahead reduction
v1n = mean(narray(1,sel_h2,2,vid));
v2n = mean(narray(2,sel_h2,2,vid));
v3n = mean(narray(3,sel_h2,2,vid));

v1d = mean(darray(1,sel_h2,2,vid));
v2d = mean(darray(2,sel_h2,2,vid));
v3d = mean(darray(3,sel_h2,2,vid));

vv1 = sqrt(v1n/v1d);
vv2 = sqrt(v2n/v2d);
vv3 = sqrt(v3n/v3d);

c2 = [vv1;vv2;vv3];

% four-step ahead reductions
v1n = mean(narray(1,sel_h4,4,vid));
v2n = mean(narray(2,sel_h4,4,vid));
v3n = mean(narray(3,sel_h4,4,vid));

v1d = mean(darray(1,sel_h4,4,vid));
v2d = mean(darray(2,sel_h4,4,vid));
v3d = mean(darray(3,sel_h4,4,vid));

vv1 = sqrt(v1n/v1d);
vv2 = sqrt(v2n/v2d);
vv3 = sqrt(v3n/v3d);

c3 = [vv1;vv2;vv3];

% twelve-step ahead reductions
v1n = mean(narray(1,sel_h12,12,vid));
v2n = mean(narray(2,sel_h12,12,vid));
v3n = mean(narray(3,sel_h12,12,vid));

v1d = mean(darray(1,sel_h12,12,vid));
v2d = mean(darray(2,sel_h12,12,vid));
v3d = mean(darray(3,sel_h12,12,vid));

vv1 = sqrt(v1n/v1d);
vv2 = sqrt(v2n/v2d);
vv3 = sqrt(v3n/v3d);

c4 = [vv1;vv2;vv3];
mat = [c1, c2, c3, c4 ];